# Class Quaternion4D.Builder

java.lang.Object
com.io7m.jtensors.core.quaternions.Quaternion4D.Builder

Enclosing class:
  `Quaternion4D`

public static final class Quaternion4D.Builder extends Object
Builds instances of type `Quaternion4D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Quaternion4D`
  `build()`
  Builds a new `Quaternion4D`.
  `final Quaternion4D.Builder`
  `from(Quaternion4DType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.quaternions.Quaternion4DType` instance.
  `final Quaternion4D.Builder`
  `from(QuaternionReadable4DType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.quaternions.QuaternionReadable4DType` instance.
  `final Quaternion4D.Builder`
  `setW(double w)`
  Initializes the value for the `w` attribute.
  `final Quaternion4D.Builder`
  `setX(double x)`
  Initializes the value for the `x` attribute.
  `final Quaternion4D.Builder`
  `setY(double y)`
  Initializes the value for the `y` attribute.
  `final Quaternion4D.Builder`
  `setZ(double z)`
  Initializes the value for the `z` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final Quaternion4D.Builder from(QuaternionReadable4DType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.quaternions.QuaternionReadable4DType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final Quaternion4D.Builder from(Quaternion4DType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.quaternions.Quaternion4DType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final Quaternion4D.Builder setX(double x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final Quaternion4D.Builder setY(double y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final Quaternion4D.Builder setZ(double z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### setW

    public final Quaternion4D.Builder setW(double w)
    Initializes the value for the `w` attribute.
    Parameters:
      `w` - The value for w
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public Quaternion4D build()
    Builds a new `Quaternion4D`.
    Returns:
      An immutable instance of Quaternion4D
    Throws:
      `IllegalStateException` - if any required attributes are missing